module BULLETCOLLIDE (clk, XA, YA, VXA, VYA, 
			   XB, YB, VXB, VYB, 
			   NEWVXA, NEWVYA, NEWVXB, NEWVYB, collision) ;

input clk ;
input [9:0] XA ;
input [8:0] YA ;
input [2:0] VXA ;
input [2:0] VYA ;
input [9:0] XB ;
input [8:0] YB ;
input [2:0] VXB ;
input [2:0] VYB ;
output [2:0] NEWVXA ;
output [2:0] NEWVYA ;
output [2:0] NEWVXB ;
output [2:0] NEWVYB ;
output collision;


reg [2:0] _NEWVXA;
reg [2:0] _NEWVXB;
reg [2:0] _NEWVYA;
reg [2:0] _NEWVYB;

assign NEWVXA = _NEWVXA;
assign NEWVXB = _NEWVXB;
assign NEWVYA = _NEWVYA;
assign NEWVYB = _NEWVYB;


reg _collision;
assign collision = _collision;

//collision occurs if XA +7 >=XB & XB + 7 >= XA & YA +7 >=YB & YB + 7 >= YA

always@(posedge clk) begin
	//collision
	if(XA +7 >= XB & XB +7 >= XA & YA +7 >= YB & YB + 7 >= YA) begin
		_collision <= 1;
		//compute new speed
		_NEWVXA <= ~VXA + 1;
		_NEWVXB <= ~VXB + 1;
		_NEWVYA <= ~VYA + 1;
		_NEWVYB <= ~VYB + 1;
	end
	else begin
		_collision <= 0;
		//keep old speed
		_NEWVXA <= VXA;
		_NEWVXB <= VXB;
		_NEWVYA <= VYA;
		_NEWVYB <= VYB;	
	end
end
endmodule 
