module CONTROLLER (CLK, NEW_KEY, ENABLE, X_COORD, Y_COORD, SCAN_CODE, value, RAND_NUM, RGB_VAL, lookup, score, resetS) ;
input CLK;
input NEW_KEY, ENABLE;
input [3:0] value;
input [9:0] X_COORD, Y_COORD;
input [7:0] SCAN_CODE;
input [9:0] RAND_NUM;
input [27:0] score;
output [2:0] RGB_VAL;
output [14:0] lookup;
output resetS;
reg [2:0] RGB_VAL;
reg [9:0] X_VAL_LOW, X_VAL_HIGH, Y_VAL_LOW, Y_VAL_HIGH, X_VAL_LINE, Y_VAL_LINE, X_LINE1, Y_LINE1;
reg [9:0] X_OBJ_POS0, X_OBJ_POS1, X_OBJ_POS2, X_OBJ_POS3, X_OBJ_POS4, X_OBJ_POS5, X_OBJ_POS6;
reg [9:0] X_OBJ_POS7, X_OBJ_POS8, X_OBJ_POS9;
reg [9:0] Y_OBJ_POS0, Y_OBJ_POS2, Y_OBJ_POS3;
reg [9:0] Y_OBJ_POS4, Y_OBJ_POS5, Y_OBJ_POS6, Y_OBJ_POS7, Y_OBJ_POS8, Y_OBJ_POS9, Y_OBJ_POS1;
reg [7:0] COUNTER2;
reg [7:0] COUNTER;
reg NEW_KEY_HOLD, Lvalid, resetS;
reg LVALID0, LVALID1, LVALID2, LVALID3, LVALID4, LVALID5, LVALID6, LVALID7, LVALID8, LVALID9;
reg [9:0] rel_x;
reg [9:0] rel_y;
reg [9:0] REL_X0, REL_X1, REL_X2, REL_X3, REL_X4, REL_X5, REL_X6, REL_X7, REL_X8, REL_X9;
reg [9:0] REL_Y0, REL_Y1, REL_Y2, REL_Y3, REL_Y4, REL_Y5, REL_Y6, REL_Y7, REL_Y8, REL_Y9;
reg [14:0] lookup;
reg [11:0] COUNTER3;
reg [16:0] COUNTER4;
reg FLAG0, FLAG1, FLAG2, FLAG3, FLAG4, FLAG5, FLAG6, FLAG7, FLAG8, FLAG9;
reg [9:0] RAND;
reg SKULL;

always @(posedge CLK) begin

	// reset step
	if(SCAN_CODE == 'h76) begin
		resetS <= 1;
		X_VAL_LOW <= 300;
		X_VAL_HIGH <= 316;
		Y_VAL_LOW <= 400;
		Y_VAL_HIGH <= 432;
		X_VAL_LINE <= 310;
		Y_VAL_LINE <= 0;
		X_LINE1 <= 310;
		Y_LINE1 <= 240;
		COUNTER2 <= 0;
		COUNTER <= 0;
		COUNTER3 <= 0;
		COUNTER4 <= 0;
		FLAG0 <= 0; FLAG1 <= 0; FLAG2 <= 0; FLAG3 <= 0; FLAG4 <= 0; FLAG5 <= 0; FLAG6 <= 0; FLAG7 <= 0;
		FLAG8 <= 0; FLAG9 <= 0;
		NEW_KEY_HOLD <= 0;
		X_OBJ_POS0 <= 255; X_OBJ_POS1 <= 279; X_OBJ_POS2 <= 303; X_OBJ_POS3 <= 327; X_OBJ_POS4 <= 351; 
		X_OBJ_POS5 <= 379; X_OBJ_POS6 <= 403; X_OBJ_POS7 <= 427; X_OBJ_POS8 <= 451; X_OBJ_POS9 <= 479;
		Y_OBJ_POS0 <= 600; Y_OBJ_POS1 <= 600; Y_OBJ_POS2 <= 600; Y_OBJ_POS3 <= 600; Y_OBJ_POS4 <= 600; 
		Y_OBJ_POS5 <= 600; Y_OBJ_POS6 <= 600; Y_OBJ_POS7 <= 600; Y_OBJ_POS8 <= 600; Y_OBJ_POS9 <= 600;
		RAND <= 0;
		SKULL <= 0;
	end
	// prepare to check keys
		
	if(ENABLE) begin		// if the logical and of HRGB and VRGB is 1, do something
		// increment counters
		resetS <= 0;
		COUNTER <= COUNTER + 1;
		if(COUNTER == 0) begin
			COUNTER2 <= COUNTER2 + 1;
			COUNTER3 <= COUNTER3 + 1;
			if(COUNTER4 == 131070) begin // largest 17 bit prime (-1 because 0 is counted)
				COUNTER4 <= 0;
			end
			else begin
				COUNTER4 <= COUNTER4 + 1;
			end
		end		
		// check to see if we have a new key
		if(NEW_KEY_HOLD == 0) begin
			NEW_KEY_HOLD <= NEW_KEY;
		end
		// if we have a new key, go to work, process input
		else begin
			if(COUNTER == 0) begin
				NEW_KEY_HOLD <= 0;
				case (SCAN_CODE)
				'h75: begin		// up arrow
					if(Y_VAL_LOW < 160) begin
						Y_VAL_LOW <= 160;
					end
					else begin
						Y_VAL_LOW <= Y_VAL_LOW - 3;
					end
					if(Y_VAL_HIGH < 193) begin
						Y_VAL_HIGH <= 193;
					end
					else begin
						Y_VAL_HIGH <= Y_VAL_HIGH - 3;
					end 
				end
				'h72: begin		// down arrow
					if(Y_VAL_LOW > 447) begin
						Y_VAL_LOW <= 447;
					end
					else begin
						Y_VAL_LOW <= Y_VAL_LOW + 3;
					end
					if(Y_VAL_HIGH > 480) begin
						Y_VAL_HIGH <= 480;
					end
					else begin
						Y_VAL_HIGH <= Y_VAL_HIGH + 3;
					end 
				end
				'h6b: begin		// left arrow
					if(X_VAL_LOW < 274) begin
						X_VAL_LOW <= 274;
					end
					else begin
						X_VAL_LOW <= X_VAL_LOW - 3;
					end
					if(X_VAL_HIGH < 290) begin
						X_VAL_HIGH <= 290;
					end
					else begin
						X_VAL_HIGH <= X_VAL_HIGH - 3;
					end 
				end
				'h74: begin		// right arrow
					if(X_VAL_LOW > 456) begin
						X_VAL_LOW <= 456;
					end
					else begin
						X_VAL_LOW <= X_VAL_LOW + 3;
					end
					if(X_VAL_HIGH > 470) begin
						X_VAL_HIGH <= 470;
					end
					else begin
						X_VAL_HIGH <= X_VAL_HIGH + 3;
					end 
				end
				'h76: begin		// escape key - return to default settings
					resetS <= 1;
					X_VAL_LOW <= 300;
					X_VAL_HIGH <= 316;
					Y_VAL_LOW <= 400;
					Y_VAL_HIGH <= 432;
					X_VAL_LINE <= 310;
					Y_VAL_LINE <= 0;
					X_LINE1 <= 310;
					Y_LINE1 <= 240;
					COUNTER <= 0;
					COUNTER2 <= 0;
					COUNTER3 <= 0;
					COUNTER4 <= 0;
					FLAG0 <= 0; FLAG1 <= 0; FLAG2 <= 0; FLAG3 <= 0; FLAG4 <= 0; 
					FLAG5 <= 0; FLAG6 <= 0; FLAG7 <= 0; FLAG8 <= 0; FLAG9 <= 0;
					X_OBJ_POS0 <= 255; X_OBJ_POS1 <= 279; X_OBJ_POS2 <= 303; X_OBJ_POS3 <= 327; X_OBJ_POS4 <= 351; 
					X_OBJ_POS5 <= 379; X_OBJ_POS6 <= 403; X_OBJ_POS7 <= 427; X_OBJ_POS8 <= 451; X_OBJ_POS9 <= 479;
					Y_OBJ_POS0 <= 600; Y_OBJ_POS1 <= 600; Y_OBJ_POS2 <= 600; Y_OBJ_POS3 <= 600; Y_OBJ_POS4 <= 600; 
					Y_OBJ_POS5 <= 600; Y_OBJ_POS6 <= 600; Y_OBJ_POS7 <= 600; Y_OBJ_POS8 <= 600; Y_OBJ_POS9 <= 600;
					RAND <= 0;
					SKULL <= 0;
				end
				'h29: begin		// space bar
				end
				default: begin		// any other key
				end
				endcase
			end // end if COUNTER==0
		end // end else begin
		
		// set up to display score		
		if(X_COORD >= 97 && X_COORD <153 && Y_COORD >= 100 && Y_COORD <= 117)begin
			rel_y <= Y_COORD - 101;
			rel_x <= X_COORD - 97;
	
		end
		
		// chose number to display	
		if(X_COORD >= 97 && X_COORD <153 && Y_COORD >= 118 && Y_COORD <= 135)begin
			REL_Y2 <= Y_COORD - 118;
			if(X_COORD >= 97 && X_COORD <105) begin // place7
				REL_X2 <= X_COORD - 97;
				lookup[14:11] <= score[27:24];
			end
			if(X_COORD >= 105 && X_COORD < 113) begin // place6
				REL_X2 <= X_COORD - 105;
				lookup[14:11] <= score[23:20];
			end
			if(X_COORD >= 113 && X_COORD <121) begin // place5
				REL_X2 <= X_COORD - 113;
				lookup[14:11] <= score[19:16];
			end
			if(X_COORD >= 121 && X_COORD <129) begin // place4
				REL_X2 <= X_COORD - 121;
				lookup[14:11] <= score[15:12];
			end
			if(X_COORD >= 129 && X_COORD <137) begin // place3
				REL_X2 <= X_COORD - 129;
				lookup[14:11] <= score[11:8];
			end
			if(X_COORD >= 137 && X_COORD <145) begin // place2
				REL_X2 <= X_COORD - 137;
				lookup[14:11] <= score[7:4];
			end
			if(X_COORD >= 145 && X_COORD <153) begin // place1
				REL_X2 <= X_COORD - 145;
				lookup[14:11] <= score[3:0];
			end
			lookup[10:7] <= 0;
			lookup[6:3] <= REL_Y2[3:0];
			lookup[2:0] <= REL_X2[2:0];	
		end
		
		
		if(X_COORD < X_VAL_HIGH && X_COORD >= X_VAL_LOW-1 && Y_COORD >= Y_VAL_LOW-1 && Y_COORD <= Y_VAL_HIGH) begin
			rel_y <= Y_COORD - Y_VAL_LOW-1;
			rel_x <= X_COORD - X_VAL_LOW+1;
		end
		
		if(X_COORD < (X_OBJ_POS0 + 16) && X_COORD >= X_OBJ_POS0-1 && Y_COORD >= Y_OBJ_POS0-1 && Y_COORD <= (Y_OBJ_POS0 + 32)) begin
			REL_Y0 <= Y_COORD - Y_OBJ_POS0-1;
			REL_X0 <= X_COORD - X_OBJ_POS0+1;
		end 
		
		if(X_COORD < (X_OBJ_POS1 + 16) && X_COORD >= X_OBJ_POS1-1 && Y_COORD >= Y_OBJ_POS1-1 && Y_COORD <= (Y_OBJ_POS1 + 32)) begin
			REL_Y1 <= Y_COORD - Y_OBJ_POS1-1;
			REL_X1 <= X_COORD - X_OBJ_POS1+1;
		end 
		
		if(X_COORD < (X_OBJ_POS2 + 16) && X_COORD >= X_OBJ_POS2-1 && Y_COORD >= Y_OBJ_POS2-1 && Y_COORD <= (Y_OBJ_POS2 + 32)) begin
			REL_Y2 <= Y_COORD - Y_OBJ_POS2-1;
			REL_X2 <= X_COORD - X_OBJ_POS2+1;
		end
		
		if(X_COORD < (X_OBJ_POS3 + 16) && X_COORD >= X_OBJ_POS3-1 && Y_COORD >= Y_OBJ_POS3-1 && Y_COORD <= (Y_OBJ_POS3 + 32)) begin
			REL_Y3 <= Y_COORD - Y_OBJ_POS3-1;
			REL_X3 <= X_COORD - X_OBJ_POS3+1;
		end 
		
		if(X_COORD < (X_OBJ_POS4 + 16) && X_COORD >= X_OBJ_POS4-1 && Y_COORD >= Y_OBJ_POS4-1 && Y_COORD <= (Y_OBJ_POS4 + 32)) begin
			REL_Y4 <= Y_COORD - Y_OBJ_POS4-1;
			REL_X4 <= X_COORD - X_OBJ_POS4+1;
		end 
		
		if(X_COORD < (X_OBJ_POS5 + 16) && X_COORD >= X_OBJ_POS5-1 && Y_COORD >= Y_OBJ_POS5-1 && Y_COORD <= (Y_OBJ_POS5 + 32)) begin
			REL_Y5 <= Y_COORD - Y_OBJ_POS5-1;
			REL_X5 <= X_COORD - X_OBJ_POS5+1;
		end 
		
		if(X_COORD < (X_OBJ_POS6 + 16) && X_COORD >= X_OBJ_POS6-1 && Y_COORD >= Y_OBJ_POS6-1 && Y_COORD <= (Y_OBJ_POS6 + 32)) begin
			REL_Y6 <= Y_COORD - Y_OBJ_POS6-1;
			REL_X6 <= X_COORD - X_OBJ_POS6+1;
		end 
		
		if(X_COORD < (X_OBJ_POS7 + 16) && X_COORD >= X_OBJ_POS7-1 && Y_COORD >= Y_OBJ_POS7-1 && Y_COORD <= (Y_OBJ_POS7 + 32)) begin
			REL_Y7 <= Y_COORD - Y_OBJ_POS7-1;
			REL_X7 <= X_COORD - X_OBJ_POS7+1;
		end 
		
		if(X_COORD < (X_OBJ_POS8 + 16) && X_COORD >= X_OBJ_POS8-1 && Y_COORD >= Y_OBJ_POS8-1 && Y_COORD <= (Y_OBJ_POS8 + 32)) begin
			REL_Y8 <= Y_COORD - Y_OBJ_POS8-1;
			REL_X8 <= X_COORD - X_OBJ_POS8+1;
		end 
		
		if(X_COORD < (X_OBJ_POS9 + 16) && X_COORD >= X_OBJ_POS9-1 && Y_COORD >= Y_OBJ_POS9-1 && Y_COORD <= (Y_OBJ_POS9 + 32)) begin
			REL_Y9 <= Y_COORD - Y_OBJ_POS9-1;
			REL_X9 <= X_COORD - X_OBJ_POS9+1;
		end 
		
		// general layout
		
		if(X_COORD == 0 && Y_COORD == 0) begin
			if(RAND_NUM == 'b1111111111) begin
				RAND <= 0;
			end
			else begin
				RAND <= RAND_NUM;
			end
		end
		
		if(X_COORD > 97 && X_COORD <= 153) begin
			if(Y_COORD > 100 && Y_COORD <= 116) begin
				lookup[14:11] <= 'b1011;
				lookup[6:3] <= rel_y[3:0];
				lookup[2:0] <= rel_x[2:0];
				lookup[10:7] <= rel_x[6:3];
			end
				
		end
		
		if(X_COORD < 274 || X_COORD > 470) begin
			if(X_COORD > 98 && X_COORD <= 154) begin
				if(Y_COORD > 99 && Y_COORD <= 132) begin
					RGB_VAL <= value[2:0];
				end
				else begin
				//	if(Y_COORD > 182 && Y_COORD < 214) begin
				//		RGB_VAL <= value[2:0];
				//	end
				//	else begin
						RGB_VAL <= 'b010;
				//	end
				end
			end
			else begin
				RGB_VAL <= 'b010;
			end
		end
		
		// roadway	
		else begin
			if(X_COORD < X_VAL_HIGH && X_COORD >= X_VAL_LOW && Y_COORD > Y_VAL_LOW && Y_COORD < Y_VAL_HIGH) begin			
				Lvalid <= 1;
				if(SKULL == 0) begin
					lookup[14:11] <= 'b1101;
				end
				else begin
					lookup[14:11] <= 'b1110;
				end
				lookup[6:3] <= rel_y[3:0];
				lookup[2:0] <= rel_x[2:0];
				lookup[8:7] <= rel_x[4:3];
				lookup[10:9] <= rel_y[5:4];
			end
			else begin
				Lvalid <= 0;
				lookup <= 0;
			end
			// draw the vehicle
			//also check for transparency		
			if(Lvalid && (value[3:3] == 1)) begin
				RGB_VAL <= value[2:0];
				//RGB_VAL <= 'b100;
			end
			else begin // 2
				// draw and update position for the centerline
				if(X_COORD > 370 && X_COORD <= 374 ) begin
					if(COUNTER2 == 0) begin
						if(Y_VAL_LINE > 479) begin
							Y_VAL_LINE <= 0;
						end
						else begin
							Y_VAL_LINE <= Y_VAL_LINE + 1;
						end
						if(Y_LINE1 > 479) begin
							Y_LINE1 <= 0;
						end
						else begin
							Y_LINE1 <= Y_LINE1 + 1;
						end
					end // end counter2 == 0
			
					// check first middle stripe
					if((Y_COORD > Y_VAL_LINE) && (Y_COORD < (Y_VAL_LINE + 50))) begin
							RGB_VAL <= 'b111;
					end // end y_COORD....
					// check second middle stripe
					else begin
						if((Y_COORD > Y_LINE1) && (Y_COORD < (Y_LINE1 + 50))) begin
							RGB_VAL <= 'b111;
			
						end // end y_COORD....
						else begin
							RGB_VAL <= 'b0;
						end
					end // else not first stripe
				end // end X_Coord ...
				
				if(X_COORD > 274 && X_COORD <= 298) begin
					if(RAND[8] == 1 && COUNTER4 == 0 && Y_OBJ_POS1 == 600) begin
						FLAG1 <= 1;
						Y_OBJ_POS1 <= 0;
					end
					if(FLAG1 == 1 && COUNTER3 == 0) begin
						if(Y_OBJ_POS1 > 479) begin
							Y_OBJ_POS1 <= 600;
							FLAG1 <= 0;
						end
						else begin
							Y_OBJ_POS1 <= Y_OBJ_POS1 + 1;
						end					
					end
					
					if(X_COORD < (X_OBJ_POS1 + 16) && X_COORD >= X_OBJ_POS1 && Y_COORD > Y_OBJ_POS1 && Y_COORD < (Y_OBJ_POS1 + 33)) begin			
						LVALID1 <= 1;
						lookup[14:11] <= 'b1010;
						lookup[6:3] <= REL_Y1[3:0];
						lookup[2:0] <= REL_X1[2:0];
						lookup[8:7] <= REL_X1[4:3];
						lookup[10:9] <= REL_Y1[5:4];
					end
					else begin
						LVALID1 <= 0;
						lookup <= 0;
					end
					
					if(((Y_VAL_LOW > Y_OBJ_POS1 && Y_VAL_LOW < (Y_OBJ_POS1 + 32)) || (Y_VAL_HIGH > Y_OBJ_POS1 && Y_VAL_HIGH < (Y_OBJ_POS1 + 32))) && ((X_VAL_LOW > X_OBJ_POS1 && X_VAL_LOW < (X_OBJ_POS1 + 16)) || (X_VAL_HIGH > X_OBJ_POS1 && X_VAL_HIGH < (X_OBJ_POS1 + 16)))) begin 
						//RGB_VAL <= 'b100;
						SKULL <= 1;
						resetS <= 1;
					end
					else begin
						if(LVALID1 && (value[3:3] == 1)) begin
							RGB_VAL <= value[2:0];
						end
						else begin
							RGB_VAL <= 'b0;
						end
					end
				end
				
				if(X_COORD > 298 && X_COORD <= 322) begin  // car 2
					if(RAND[7] == 1 && COUNTER4 == 0 && Y_OBJ_POS2 == 600) begin
						FLAG2 <= 1;
						Y_OBJ_POS2 <= 0;
					end
					if(FLAG2 == 1 && COUNTER3 == 0) begin
						if(Y_OBJ_POS2 > 479) begin
							Y_OBJ_POS2 <= 600;
							FLAG2 <= 0;
						end
						else begin
							Y_OBJ_POS2 <= Y_OBJ_POS2 + 1;
						end
					end
					
					if(X_COORD < (X_OBJ_POS2 + 16) && X_COORD >= X_OBJ_POS2 && Y_COORD > Y_OBJ_POS2 && Y_COORD < (Y_OBJ_POS2 + 33)) begin			
						LVALID2 <= 1;
						lookup[14:11] <= 'b1010;
						lookup[6:3] <= REL_Y2[3:0];
						lookup[2:0] <= REL_X2[2:0];
						lookup[8:7] <= REL_X2[4:3];
						lookup[10:9] <= REL_Y2[5:4];
					end
					else begin
						LVALID2 <= 0;
						lookup <= 0;
					end

					if(((Y_VAL_LOW > Y_OBJ_POS2 && Y_VAL_LOW < (Y_OBJ_POS2 + 32)) || (Y_VAL_HIGH > Y_OBJ_POS2 && Y_VAL_HIGH < (Y_OBJ_POS2 + 32))) && ((X_VAL_LOW > X_OBJ_POS2 && X_VAL_LOW < (X_OBJ_POS2 + 16)) || (X_VAL_HIGH > X_OBJ_POS2 && X_VAL_HIGH < (X_OBJ_POS2 + 16)))) begin 
						//RGB_VAL <= 'b110;
						SKULL <= 1;
						resetS <= 1;
					end
					else begin
						if(LVALID2 && (value[3:3] == 1)) begin
							RGB_VAL <= value[2:0];
						end
						else begin
							RGB_VAL <= 'b0;
						end
					end
				end
				
				if(X_COORD > 322 && X_COORD <= 346) begin
					if(RAND[6] == 1 && COUNTER4 == 0 && Y_OBJ_POS3 == 600) begin
						FLAG3 <= 1;
						Y_OBJ_POS3 <= 0;
					end
					if(FLAG3 == 1 && COUNTER3 == 0) begin
						if(Y_OBJ_POS3 > 479) begin
							Y_OBJ_POS3 <= 600;
							FLAG3 <= 0;
						end
						else begin
							Y_OBJ_POS3 <= Y_OBJ_POS3 + 1;
						end
					end
					
					if(X_COORD < (X_OBJ_POS3 + 16) && X_COORD >= X_OBJ_POS3 && Y_COORD > Y_OBJ_POS3 && Y_COORD < (Y_OBJ_POS3 + 33)) begin			
						LVALID3 <= 1;
						lookup[14:11] <= 'b1010;
						lookup[6:3] <= REL_Y3[3:0];
						lookup[2:0] <= REL_X3[2:0];
						lookup[8:7] <= REL_X3[4:3];
						lookup[10:9] <= REL_Y3[5:4];
					end
					else begin
						LVALID3 <= 0;
						lookup <= 0;
					end

					if(((Y_VAL_LOW > Y_OBJ_POS3 && Y_VAL_LOW < (Y_OBJ_POS3 + 32)) || (Y_VAL_HIGH > Y_OBJ_POS3 && Y_VAL_HIGH < (Y_OBJ_POS3 + 32))) && ((X_VAL_LOW > X_OBJ_POS3 && X_VAL_LOW < (X_OBJ_POS3 + 16)) || (X_VAL_HIGH > X_OBJ_POS3 && X_VAL_HIGH < (X_OBJ_POS3 + 16)))) begin 
						//RGB_VAL <= 'b110;
						SKULL <= 1;
						resetS <= 1;
					end
					else begin
						if(LVALID3 && (value[3:3] == 1)) begin
							RGB_VAL <= value[2:0];
						end
						else begin
							RGB_VAL <= 'b0;
						end
					end
				end
				
				if(X_COORD > 346 && X_COORD <= 370) begin
					if(RAND[5] == 1 && COUNTER4 == 0 && Y_OBJ_POS4 == 600) begin
						FLAG4 <= 1;
						Y_OBJ_POS4 <= 0;
					end
					if(FLAG4 == 1 && COUNTER3 == 0) begin
						if(Y_OBJ_POS4 > 479) begin
							Y_OBJ_POS4 <= 600;
							FLAG4 <= 0;
						end
						else begin
							Y_OBJ_POS4 <= Y_OBJ_POS4 + 1;
						end
					end
					
					if(X_COORD < (X_OBJ_POS4 + 16) && X_COORD >= X_OBJ_POS4 && Y_COORD > Y_OBJ_POS4 && Y_COORD < (Y_OBJ_POS4 + 33)) begin			
						LVALID4 <= 1;
						lookup[14:11] <= 'b1010;
						lookup[6:3] <= REL_Y4[3:0];
						lookup[2:0] <= REL_X4[2:0];
						lookup[8:7] <= REL_X4[4:3];
						lookup[10:9] <= REL_Y4[5:4];
					end
					else begin
						LVALID4 <= 0;
						lookup <= 0;
					end

					if(((Y_VAL_LOW > Y_OBJ_POS4 && Y_VAL_LOW < (Y_OBJ_POS4 + 32)) || (Y_VAL_HIGH > Y_OBJ_POS4 && Y_VAL_HIGH < (Y_OBJ_POS4 + 32))) && ((X_VAL_LOW > X_OBJ_POS4 && X_VAL_LOW < (X_OBJ_POS4 + 16)) || (X_VAL_HIGH > X_OBJ_POS4 && X_VAL_HIGH < (X_OBJ_POS4 + 16)))) begin 
						//RGB_VAL <= 'b110;
						SKULL <= 1;
						resetS <= 1;
					end
					else begin
						if(LVALID4 && (value[3:3] == 1)) begin
							RGB_VAL <= value[2:0];
						end
						else begin
							RGB_VAL <= 'b0;
						end
					end
				end
				
				if(X_COORD > 374 && X_COORD <= 398) begin
					if(RAND[4] == 1 && COUNTER4 == 0 && Y_OBJ_POS5 == 600) begin
						FLAG5 <= 1;
						Y_OBJ_POS5 <= 0;
					end
					if(FLAG5 == 1 && COUNTER3 == 0) begin
						if(Y_OBJ_POS5 > 479) begin
							Y_OBJ_POS5 <= 600;
							FLAG5 <= 0;
						end
						else begin
							Y_OBJ_POS5 <= Y_OBJ_POS5 + 1;
						end
					end
					
					if(X_COORD < (X_OBJ_POS5 + 16) && X_COORD >= X_OBJ_POS5 && Y_COORD > Y_OBJ_POS5 && Y_COORD < (Y_OBJ_POS5 + 33)) begin			
						LVALID5 <= 1;
						lookup[14:11] <= 'b1010;
						lookup[6:3] <= REL_Y5[3:0];
						lookup[2:0] <= REL_X5[2:0];
						lookup[8:7] <= REL_X5[4:3];
						lookup[10:9] <= REL_Y5[5:4];
					end
					else begin
						LVALID5 <= 0;
						lookup <= 0;
					end

					if(((Y_VAL_LOW > Y_OBJ_POS5 && Y_VAL_LOW < (Y_OBJ_POS5 + 32)) || (Y_VAL_HIGH > Y_OBJ_POS5 && Y_VAL_HIGH < (Y_OBJ_POS5 + 32))) && ((X_VAL_LOW > X_OBJ_POS5 && X_VAL_LOW < (X_OBJ_POS5 + 16)) || (X_VAL_HIGH > X_OBJ_POS5 && X_VAL_HIGH < (X_OBJ_POS5 + 16)))) begin 
						//RGB_VAL <= 'b110;
						SKULL <= 1;
						resetS <= 1;
					end
					else begin
						if(LVALID5 && (value[3:3] == 1)) begin
							RGB_VAL <= value[2:0];
						end
						else begin
							RGB_VAL <= 'b0;
						end
					end
				end
				
				if(X_COORD > 398 && X_COORD <= 422) begin
					if(RAND[3] == 1 && COUNTER4 == 0 && Y_OBJ_POS6 == 600) begin
						FLAG6 <= 1;
						Y_OBJ_POS6 <= 0;
					end
					if(FLAG6 == 1 && COUNTER3 == 0) begin
						if(Y_OBJ_POS6 > 479) begin
							Y_OBJ_POS6 <= 600;
							FLAG6 <= 0;
						end
						else begin
							Y_OBJ_POS6 <= Y_OBJ_POS6 + 1;
						end
					end
					
					if(X_COORD < (X_OBJ_POS6 + 16) && X_COORD >= X_OBJ_POS6 && Y_COORD > Y_OBJ_POS6 && Y_COORD < (Y_OBJ_POS6 + 33)) begin			
						LVALID6 <= 1;
						lookup[14:11] <= 'b1010;
						lookup[6:3] <= REL_Y6[3:0];
						lookup[2:0] <= REL_X6[2:0];
						lookup[8:7] <= REL_X6[4:3];
						lookup[10:9] <= REL_Y6[5:4];
					end
					else begin
						LVALID6 <= 0;
						lookup <= 0;
					end

					if(((Y_VAL_LOW > Y_OBJ_POS6 && Y_VAL_LOW < (Y_OBJ_POS6 + 32)) || (Y_VAL_HIGH > Y_OBJ_POS6 && Y_VAL_HIGH < (Y_OBJ_POS6 + 32))) && ((X_VAL_LOW > X_OBJ_POS6 && X_VAL_LOW < (X_OBJ_POS6 + 16)) || (X_VAL_HIGH > X_OBJ_POS6 && X_VAL_HIGH < (X_OBJ_POS6 + 16)))) begin 
						//RGB_VAL <= 'b110;
						SKULL <= 1;
						resetS <= 1;
					end
					else begin
						if(LVALID6 && (value[3:3] == 1)) begin
							RGB_VAL <= value[2:0];
						end
						else begin
							RGB_VAL <= 'b0;
						end
					end
				end
				
				if(X_COORD > 422 && X_COORD <= 446) begin
					if(RAND[2] == 1 && COUNTER4 == 0 && Y_OBJ_POS7 == 600) begin
						FLAG7 <= 1;
						Y_OBJ_POS7 <= 0;
					end
					if(FLAG7 == 1 && COUNTER3 == 0) begin
						if(Y_OBJ_POS7 > 479) begin
							Y_OBJ_POS7 <= 600;
							FLAG7 <= 0;
						end
						else begin
							Y_OBJ_POS7 <= Y_OBJ_POS7 + 1;
						end
					
					end
					
					if(X_COORD < (X_OBJ_POS7 + 16) && X_COORD >= X_OBJ_POS7 && Y_COORD > Y_OBJ_POS7 && Y_COORD < (Y_OBJ_POS7 + 33)) begin			
						LVALID7 <= 1;
						lookup[14:11] <= 'b1010;
						lookup[6:3] <= REL_Y7[3:0];
						lookup[2:0] <= REL_X7[2:0];
						lookup[8:7] <= REL_X7[4:3];
						lookup[10:9] <= REL_Y7[5:4];
					end
					else begin
						LVALID7 <= 0;
						lookup <= 0;
					end

					if(((Y_VAL_LOW > Y_OBJ_POS7 && Y_VAL_LOW < (Y_OBJ_POS7 + 32)) || (Y_VAL_HIGH > Y_OBJ_POS7 && Y_VAL_HIGH < (Y_OBJ_POS7 + 32))) && ((X_VAL_LOW > X_OBJ_POS7 && X_VAL_LOW < (X_OBJ_POS7 + 16)) || (X_VAL_HIGH > X_OBJ_POS7 && X_VAL_HIGH < (X_OBJ_POS7 + 16)))) begin 
						//RGB_VAL <= 'b110;
						SKULL <= 1;
						resetS <= 1;
					end
					else begin
						if(LVALID7 && (value[3:3] == 1)) begin
							RGB_VAL <= value[2:0];
						end
						else begin
							RGB_VAL <= 'b0;
						end
					end
				end
				
				if(X_COORD > 446 && X_COORD <= 470) begin
					if(RAND[1] == 1 && COUNTER4 == 0 && Y_OBJ_POS8 == 600) begin
						FLAG8 <= 1;
						Y_OBJ_POS8 <= 0;
					end
					if(FLAG8 == 1 && COUNTER3 == 0) begin
						if(Y_OBJ_POS8 > 479) begin
							Y_OBJ_POS8 <= 600;
							FLAG8 <= 0;
						end
						else begin
							Y_OBJ_POS8 <= Y_OBJ_POS8 + 1;
						end
					
					end
					
					if(X_COORD < (X_OBJ_POS8 + 16) && X_COORD >= X_OBJ_POS8 && Y_COORD > Y_OBJ_POS8 && Y_COORD < (Y_OBJ_POS8 + 33)) begin			
						LVALID8 <= 1;
						lookup[14:11] <= 'b1010;
						lookup[6:3] <= REL_Y8[3:0];
						lookup[2:0] <= REL_X8[2:0];
						lookup[8:7] <= REL_X8[4:3];
						lookup[10:9] <= REL_Y8[5:4];
					end
					else begin
						LVALID8 <= 0;
						lookup <= 0;
					end

					if(((Y_VAL_LOW > Y_OBJ_POS8 && Y_VAL_LOW < (Y_OBJ_POS8 + 32)) || (Y_VAL_HIGH > Y_OBJ_POS8 && Y_VAL_HIGH < (Y_OBJ_POS8 + 32))) && ((X_VAL_LOW > X_OBJ_POS8 && X_VAL_LOW < (X_OBJ_POS8 + 16)) || (X_VAL_HIGH > X_OBJ_POS8 && X_VAL_HIGH < (X_OBJ_POS8 + 16)))) begin 
						//RGB_VAL <= 'b110;
						SKULL <= 1;
						resetS <= 1;
					end
					else begin
						if(LVALID8 && (value[3:3] == 1)) begin
							RGB_VAL <= value[2:0];
						end
						else begin
							RGB_VAL <= 'b0;
						end
					end
				end
				
			end // else begin 2
		end // else begin road
	
	end // enable
	
end // end always block

endmodule 
